Package org.codehaus.plexus.util.xml

# Class Xpp3DomUtils

java.lang.Object
org.codehaus.plexus.util.xml.Xpp3DomUtils

public class Xpp3DomUtils extends Object

Author:
  Jason van Zyl

## Field Summary

Fields
Modifier and Type
Field
Description
`static final String`
`CHILDREN_COMBINATION_APPEND`
`static final String`
`CHILDREN_COMBINATION_MERGE`
`static final String`
`CHILDREN_COMBINATION_MODE_ATTRIBUTE`
`static final String`
`DEFAULT_CHILDREN_COMBINATION_MODE`
This default mode for combining children DOMs during merge means that where element names match, the process will try to merge the element data, rather than putting the dominant and recessive elements (which share the same element name) as siblings in the resulting DOM.
`static final String`
`DEFAULT_SELF_COMBINATION_MODE`
This default mode for combining a DOM node during merge means that where element names match, the process will try to merge the element attributes and values, rather than overriding the recessive element completely with the dominant one.
`static final String`
`ID_COMBINATION_MODE_ATTRIBUTE`
In case of complex XML structures, combining can be done based on id.
`static final String`
`KEYS_COMBINATION_MODE_ATTRIBUTE`
In case of complex XML structures, combining can be done based on keys.
`static final String`
`SELF_COMBINATION_MERGE`
`static final String`
`SELF_COMBINATION_MODE_ATTRIBUTE`
`static final String`
`SELF_COMBINATION_OVERRIDE`

## Constructor Summary

Constructors
Constructor
Description
`Xpp3DomUtils()`

## Method Summary

Modifier and Type
Method
Description
`static boolean`
`isEmpty(String str)`
`static boolean`
`isNotEmpty(String str)`
`static Xpp3Dom`
`mergeXpp3Dom(Xpp3Dom dominant, Xpp3Dom recessive)`
Merge two DOMs, with one having dominance in the case of collision.
`static Xpp3Dom`
`mergeXpp3Dom(Xpp3Dom dominant, Xpp3Dom recessive, Boolean childMergeOverride)`
Merge two DOMs, with one having dominance in the case of collision.
`void`
`writeToSerializer(String namespace, XmlSerializer serializer, Xpp3Dom dom)`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Field Details

### CHILDREN_COMBINATION_MODE_ATTRIBUTE

public static final String CHILDREN_COMBINATION_MODE_ATTRIBUTE

See Also:
  - Constant Field Values

### CHILDREN_COMBINATION_MERGE

public static final String CHILDREN_COMBINATION_MERGE

See Also:
  - Constant Field Values

### CHILDREN_COMBINATION_APPEND

public static final String CHILDREN_COMBINATION_APPEND

See Also:
  - Constant Field Values

### DEFAULT_CHILDREN_COMBINATION_MODE

public static final String DEFAULT_CHILDREN_COMBINATION_MODE
This default mode for combining children DOMs during merge means that where element names match, the process will try to merge the element data, rather than putting the dominant and recessive elements (which share the same element name) as siblings in the resulting DOM.

See Also:
  - Constant Field Values

### SELF_COMBINATION_MODE_ATTRIBUTE

public static final String SELF_COMBINATION_MODE_ATTRIBUTE

See Also:
  - Constant Field Values

### SELF_COMBINATION_OVERRIDE

public static final String SELF_COMBINATION_OVERRIDE

See Also:
  - Constant Field Values

### SELF_COMBINATION_MERGE

public static final String SELF_COMBINATION_MERGE

See Also:
  - Constant Field Values

### ID_COMBINATION_MODE_ATTRIBUTE

public static final String ID_COMBINATION_MODE_ATTRIBUTE
In case of complex XML structures, combining can be done based on id.

Since:
  3.0.22
See Also:
  - Constant Field Values

### KEYS_COMBINATION_MODE_ATTRIBUTE

public static final String KEYS_COMBINATION_MODE_ATTRIBUTE
In case of complex XML structures, combining can be done based on keys. This is a comma separated list of attribute names.

Since:
  3.4.0
See Also:
  - Constant Field Values

### DEFAULT_SELF_COMBINATION_MODE

public static final String DEFAULT_SELF_COMBINATION_MODE
This default mode for combining a DOM node during merge means that where element names match, the process will try to merge the element attributes and values, rather than overriding the recessive element completely with the dominant one. This means that wherever the dominant element doesn't provide the value or a particular attribute, that value or attribute will be set from the recessive DOM node.

See Also:
  - Constant Field Values

## Constructor Details

### Xpp3DomUtils

public Xpp3DomUtils()

## Method Details

### writeToSerializer

public void writeToSerializer(String namespace, XmlSerializer serializer, Xpp3Dom dom) throws IOException

Throws:
  `IOException`

### mergeXpp3Dom

public static Xpp3Dom mergeXpp3Dom(Xpp3Dom dominant, Xpp3Dom recessive, Boolean childMergeOverride)
Merge two DOMs, with one having dominance in the case of collision.

Parameters:
  `dominant` - The dominant DOM into which the recessive value/attributes/children will be merged
  `recessive` - The recessive DOM, which will be merged into the dominant DOM
  `childMergeOverride` - Overrides attribute flags to force merging or appending of child elements into the dominant DOM
Returns:
  merged DOM
See Also:
  - `CHILDREN_COMBINATION_MODE_ATTRIBUTE`
  - `SELF_COMBINATION_MODE_ATTRIBUTE`

### mergeXpp3Dom

public static Xpp3Dom mergeXpp3Dom(Xpp3Dom dominant, Xpp3Dom recessive)
Merge two DOMs, with one having dominance in the case of collision. Merge mechanisms (vs. override for nodes, or vs. append for children) is determined by attributes of the dominant root node.

Parameters:
  `dominant` - The dominant DOM into which the recessive value/attributes/children will be merged
  `recessive` - The recessive DOM, which will be merged into the dominant DOM
Returns:
  merged DOM
See Also:
  - `CHILDREN_COMBINATION_MODE_ATTRIBUTE`
  - `SELF_COMBINATION_MODE_ATTRIBUTE`

### isNotEmpty

public static boolean isNotEmpty(String str)

### isEmpty

public static boolean isEmpty(String str)